app.controller('AppCtrl', function ($scope, $ionicModal, $ionicPopover, $timeout, $location, $ionicLoading, $cordovaSQLite) {
    // Form data for the login modal
    $scope.loginData = {};
    $scope.langName = 'En';
    $scope.isAr = false;
    $scope.left = 'left';
    $scope.right = 'right';
    $scope.Home = '';
    $scope.Animals = '';
    $scope.News = '';
    $scope.Ticket = '';
    $scope.Vistores = '';
    $scope.InternalMap = '';
    $scope.OutSideMap = '';
    $scope.About = '';
    $scope.ServiceCategory = '';
    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;
    

    $scope.VideoImage = '';
    $scope.VisitRequest = '';
    $scope.Suggestation = '';
    $scope.Questionnaire = 'Aquestionnaire';
    $scope.Settings = '';
    $scope.DeleteCookiesTitle = '';
    $scope.TwitterLoginTitle = '';
    $scope.Login = '';

    $scope.itemCount = 0;

    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
      
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.langName = "En";
            $scope.left = 'left';
            $scope.right = 'right';
            $scope.Home = 'Home';
            $scope.Animals = 'Animals';
            $scope.News = 'News';
            $scope.Ticket = 'Ticket';
            $scope.Vistores = 'Vistores';
            $scope.InternalMap = 'Internal Map';
            $scope.OutSideMap = 'OutSide Map';
            $scope.About = 'About';
            $scope.ServiceCategory = 'Service Category';
            $scope.VideoImage = 'Videos and Images';
            $scope.VisitRequest = 'Visit Request';
            $scope.Suggestation = 'Complaints proposals';
            $scope.Competitions = 'Competitions';
            $scope.knowledge = 'Zoo Knowledge';
            $scope.Questionnaire = 'Aquestionnaire';
            $scope.Settings = 'Settings';
            $scope.DeleteCookies = 'Delete Cookies';
            $scope.TwitterLogin = 'Twitter Login';
            $scope.Login = 'Login & Twitter Login';

        } else {
            $scope.isAr = true;
            $scope.langName = "العربية";
            $scope.left = 'right';
            $scope.right = 'left';
            $scope.Home = 'الرئيسية';
            $scope.Animals = 'الحيوانات';
            $scope.News = 'الاخبار';
            $scope.Ticket = 'التذاكر';
            $scope.Vistores = 'الزوار';
            $scope.InternalMap = 'الخريطة الداخلية';
            $scope.OutSideMap = 'الخريطة الخارجية';
            $scope.About = 'عن التطبيق';
            $scope.ServiceCategory = 'الخدمات';
            $scope.VideoImage = 'معرض الفيديوهات و الصور';
            $scope.VisitRequest = 'طلب زيارة';
            $scope.Suggestation = 'الشكاوى و المقترحات';
            $scope.Competitions = 'المسابقات';
            $scope.knowledge = 'التعريف بالحديقة';
            $scope.Questionnaire = 'استبيان';
            $scope.Settings = 'الاعدادات';
            $scope.DeleteCookiesTitle = 'مسح البيانات';
            $scope.TwitterLoginTitle = 'التسجيل بتويتر';
            $scope.Login = 'تسجيل الدخول';
        }
        
    });
    //$scope.populateCounter();
    $scope.populateCounter = function () {
      $ionicLoading.show({
        template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
      });
      var db = null;
      // for opening a background db:
      
      if (window.cordova) {
        //alert($cordovaSQLite);
        db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
        //alert($cordovaSQLite);
        //alert("Android");
      } else {
        db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
        //alert("browser");

      } 
      db.transaction(function (tx) {
        $ionicLoading.hide();
        //tx.executeSql('DROP TABLE IF EXISTS UserData');
        tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
        //db.transaction(function (tx) {
          //tx.executeSql('DROP TABLE IF EXISTS UserData');
          //tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
          tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
            
            if (rs.rows.length > 0) {
              //alert('there is data');
              $scope.isLogged = true;
              $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
              $scope.userId = rs.rows.item(0).UserID;
              $scope.UserType = rs.rows.item(0).UserType;

              $ionicLoading.hide();
              $http.get('http://ksazoo.com/breeze/mobile/GetUserVisitRequests?userId=' + $scope.userId)
                .success(function (data) {

                  //return $scope.requestData(data);
                  alert(data.length);
                  if (data)
                    $scope.itemCount = data.length;
                  

                })
                .error(function (e) {
                  deferred.reject();
                  console.log('error');
                  $ionicLoading.hide();
                  $scope.populateData(null);
                  if ($scope.isAr) {
                    $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                  } else {
                    $scope.showAlert('Internet Connection', 'No Internet Connection');
                  }

                  //$scope.$broadcast('scroll.refreshComplete');


                });
            } else {
              $scope.isLogged = false;
              $ionicLoading.hide();
            }
          }, function (tx, error) {
            alert('SELECT error: ' + error.message);
            $ionicLoading.hide();
          //});
        });
      });
    }
    
    var navIcons = document.getElementsByClassName('ion-navicon');
    for (var i = 0; i < navIcons.length; i++) {
        navIcons.addEventListener('click', function () {
            this.classList.toggle('active');
        });
    }

    var fab = document.getElementById('fab');
    fab.addEventListener('click', function () {
        //location.href = 'https://twitter.com/satish_vr2011';
        window.open('https://twitter.com/satish_vr2011', '_blank');
    });

    // .fromTemplate() method
    var template = '<ion-popover-view>' +
                    '   <ion-header-bar>' +
                    '       <h1 class="title">My Popover Title</h1>' +
                    '   </ion-header-bar>' +
                    '   <ion-content class="padding">' +
                    '       My Popover Contents' +
                    '   </ion-content>' +
                    '</ion-popover-view>';

    $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
    });
    $scope.closePopover = function () {
        $scope.popover.hide();
    };
    //Cleanup the popover when we're done with it!
    $scope.$on('$destroy', function () {
        $scope.popover.remove();
    });
    $scope.navigateLang = function () {
        if ($scope.langName == "En") {
            document.cookie = 'zooWeb' + '=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';
            document.cookie = "zooWeb=ar";
            //location.reload();
            window.location.hash = '#';
            window.location.reload();
        }
        else {
            document.cookie = 'zooWeb' + '=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';
            document.cookie = "zooWeb=en";
            //location.reload();
            window.location.hash = '#';
            window.location.reload();
        }
    };
    $scope.goToRequests = function () {
      alert('done');
      //if ($scope.isLogged && $scope.itemCount>0) {
      //  $location.path('/requests');
      //} else {

      //}
    };

});
