app.controller('QuestionnaireDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite, $cordovaCamera, $cordovaFile, $cordovaFileTransfer, $cordovaDevice, $ionicPopup, $cordovaActionSheet) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.dataQuestion = {};
    $scope.isAr = false;
    $scope.addC = false;
    $scope.comment = {};

    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;


    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
        } else {
            $scope.isAr = true;
        }
        $scope.getUser();
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        }
    });
    $scope.getData = function (Id) {
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        var deferred = $q.defer()

        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM Questions where ID = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    
                        $scope.dataQuestion = {
                            ID: rs.rows.item(0).ID,
                            QuestionText: rs.rows.item(0).QuestionText,
                            QuestionTextAr: rs.rows.item(0).QuestionTextAr,
                            IsChoosed: rs.rows.item(0).IsChoosed,
                            QuestionnaireId: rs.rows.item(0).QuestionnaireId,
                            
                        };
                    

                    $ionicLoading.hide();
                }
                tx.executeSql('SELECT * FROM QuestionOptions where QuestionId = ' + Id, [], function (tx, rs) {
                    if (rs.rows.length > 0) {
                        for (var i = 0; i < rs.rows.length; i++) {

                            $scope.data.push({
                                ID: rs.rows.item(i).ID,
                                Name: rs.rows.item(i).Name,
                                NameAr: rs.rows.item(i).NameAr,
                                IsChoosed: rs.rows.item(i).IsChoosed,
                                QuestionId: rs.rows.item(i).QuestionId,
                                questionnaireId: rs.rows.item(i).questionnaireId
                            });
                        }

                        $ionicLoading.hide();
                    }

                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        
        
    };
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/ionic.png'
        }
    };
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };
    $scope.addComment = function () {
        if ($scope.addC == false) {
            $scope.addC = true;
        } else {
            $scope.addC = false;
        }
    };
    $scope.sendComment = function () {

    };
    $scope.q = {};

    
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
    $scope.checkRadio = function (item) {
        if ($scope.isLogged == false) {
            if ($scope.isAr == true) {
                $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
            } else {
                $scope.showAlert('Error', 'Please Login First.');
            }
            return;

        }
        $ionicLoading.show({
          template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        $scope.q = item;
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('update QuestionOptions set IsChoosed = 0 where QuestionId = ' + $scope.q.QuestionId, [], function (tx, rs) {
                tx.executeSql('update QuestionOptions set IsChoosed = 1 where ID = ' + $scope.q.ID, [], function (tx, rs) {
                    $http.get('http://ksazoo.com/breeze/mobile/AddQuestionnaireAnswer?questionnaireId=' + $scope.q.questionnaireId + '&userId=' + $scope.userId + '&questionId=' + $scope.q.QuestionId + '&optionId=' + $scope.q.ID)
                      .success(function (data) {
                        $ionicLoading.hide();
                        if (data == 1) {
                            $scope.showAlert('Success', 'Data Send');
                        } else {
                            $scope.showAlert('Error', 'Data Send Error');
                        }
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function (e) {
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });

                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });

            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
            
        });
        
    };
    $scope.getUser = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            //tx.executeSql('DROP TABLE IF EXISTS UserData');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

});
