﻿app.controller('ServiceDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite,$timeout) {
    //ionic.material.ink.displayEffect();
    $scope.data = null;
    $scope.menuItems = [];
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        $scope.data = null;
        $scope.menuItems = [];
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        }
    });
    $scope.getData = function (Id) {
        //$scope.data = null;
        //$scope.menuItems = [];
        
                //$ionicLoading.show({
                //    template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
                //});
                var db = null;
            // for opening a background db:
                var d = $q.defer();
                if (window.cordova) {
                    db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
                    //alert("Android");
                } else {
                    db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
                    //alert("browser");

                }
        
                db.transaction(function (tx) {
            
                        tx.executeSql('SELECT * FROM Services where ID = ' + Id, [], function (tx, rs) {
                            if (rs.rows.length > 0) {
                                $scope.data = {
                                    ID: rs.rows.item(0).ID,
                                    Name: rs.rows.item(0).Name,
                                    NameAr: rs.rows.item(0).NameAr,
                                    Description: rs.rows.item(0).Description,
                                    DescriptionAr: rs.rows.item(0).DescriptionAr,
                                    Details: rs.rows.item(0).Details,
                                    DetailsAr: rs.rows.item(0).DetailsAr,
                                    MainImage: rs.rows.item(0).MainImage,
                                    Map: rs.rows.item(0).Map,
                                    MenuItem: []
                                };
                                
                                    tx.executeSql('SELECT * FROM Menus where ServiceId = ' + Id, [], function (tx, rs) {
                                        if (rs.rows.length > 0) {
                                            var menuId = rs.rows.item(0).ID;
                                            tx.executeSql('SELECT * FROM MenuItems where MenuId = ' + menuId, [], function (tx, rs) {
                                                if (rs.rows.length > 0) {
                                                    $timeout(function () {
                                                    for (var i = 0; i < rs.rows.length; i++) {
                                                        d.resolve($scope.menuItems.push({
                                                            ID: rs.rows.item(i).ID,
                                                            Title: rs.rows.item(i).Title,
                                                            TitleAr: rs.rows.item(i).TitleAr,
                                                            Description: rs.rows.item(i).Description,
                                                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                                                            Details: rs.rows.item(i).Details,
                                                            DetailsAr: rs.rows.item(i).DetailsAr,
                                                            MainImage: rs.rows.item(i).MainImage,
                                                            Price: rs.rows.item(i).Price,
                                                            CreatedAt: rs.rows.item(i).CreatedAt,
                                                            ModifiedAt: rs.rows.item(i).ModifiedAt,
                                                        }));
                                                    }
                                                    }, 200);

                                                }

                                            });
                                        };
                                        $ionicLoading.hide();
                                    });
                                
                                $ionicLoading.hide();
                            }
                            //else {
                            //    var deferred = $q.defer()
                            //    $http.get('http://ksazoo.com/breeze/mobile/getServiceDetails?Id=' + Id)
                            //    .success(function (data) {
                            //        deferred.resolve(data);
                            //        $scope.data = data;
                            //        $ionicLoading.hide();
                            //        $scope.$broadcast('scroll.refreshComplete');
                            //    })
                            //    .error(function (e) {
                            //        deferred.reject();
                            //        console.log('error');
                            //        $ionicLoading.hide();
                            //        $scope.$broadcast('scroll.refreshComplete');
                            //    });
                            //    $scope.data = deferred.promise;
                            //}
                        }, function (tx, error) {
                            alert('SELECT error: ' + error.message);
                            $ionicLoading.hide();
                        });
            
            
            
                
            
               
            
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
       

        
        return d.promise;
    };
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };

});