﻿app.controller('SuggestationCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite, $cordovaCamera, $cordovaFile, $cordovaFileTransfer, $cordovaDevice, $ionicPopup, $cordovaActionSheet) {
    //ionic.material.ink.displayEffect();
    $scope.suggest = '';
    $scope.Problem = '';
    $scope.follow = '';
    $scope.s = true;
    $scope.p = false;
    $scope.name = {};
    $scope.mobile = {};
    $scope.mail = {};
    $scope.notes = {};
    $scope.value1 = '3';

    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;
    $scope.AddImage = '';
    $scope.SendProblem = '';


    $scope.data = [];
    $scope.suggestation = '';

    $scope.Name = '';
    $scope.Mobile = '';
    $scope.Email = '';
    $scope.Note = '';
    $scope.isAr = false;
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    //$scope.getData();
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return i;
        } else {
            return 'zoo-logo.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.suggest = 'Suggest';
            $scope.Problem = 'Problem';
            $scope.suggestation = 'Suggestation and problems';
            $scope.follow = 'Follow Up';
            $scope.AddImage = 'Add Image';
            $scope.SendProblem = 'Send Problem';
            $scope.Name = 'Name';
            $scope.Mobile = 'Mobile';
            $scope.Email = 'Email';
            $scope.Note = 'Note';
        } else {
            $scope.isAr = true;
            $scope.suggest = 'اقتراح';
            $scope.Problem = 'شكوى';
            $scope.suggestation = 'الاقتراحات و الشكاوى';
            $scope.follow = 'متابعة';
            $scope.AddImage = 'اضافة صورة';
            $scope.SendProblem = 'ارسال المشكلة';
            $scope.Name = 'الاسم';
            $scope.Mobile = 'الجوال';
            $scope.Email = 'الايميل';
            $scope.Note = 'ملاحظات';
        }
        $scope.getUser();
    });

    $scope.image = null;
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };


    $scope.loadImage = function () {
        //if ($scope.isLogged == false) {
        //    if ($scope.isAr == true) {
        //        $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
        //    } else {
        //        $scope.showAlert('Error', 'Please Login First.');
        //    }
        //    return;
        //}
        var options = {
            title: 'Select Image Source',
            buttonLabels: ['Load from Library', 'Use Camera'],
            addCancelButtonWithLabel: 'Cancel',
            androidEnableCancelButton: true,
        };
        $cordovaActionSheet.show(options).then(function (btnIndex) {
            var type = null;
            if (btnIndex === 1) {
                type = Camera.PictureSourceType.PHOTOLIBRARY;
            } else if (btnIndex === 2) {
                type = Camera.PictureSourceType.CAMERA;
            }
            if (type !== null) {
                $scope.selectPicture(type);
            }
        });
    };


    $scope.selectPicture = function (sourceType) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: sourceType,
            saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imagePath) {
            // Grab the file name of the photo in the temporary directory
            var currentName = imagePath.replace(/^.*[\\\/]/, '');

            //Create a new name for the photo
            var d = new Date(),
            n = d.getTime(),
            newFileName = n + ".jpg";

            // If you are trying to load image from the gallery on Android we need special treatment!
            if ($cordovaDevice.getPlatform() == 'Android' && sourceType === Camera.PictureSourceType.PHOTOLIBRARY) {
                window.FilePath.resolveNativePath(imagePath, function (entry) {
                    window.resolveLocalFileSystemURL(entry, success, fail);
                    function fail(e) {
                        console.error('Error: ', e);
                    }

                    function success(fileEntry) {
                        var namePath = fileEntry.nativeURL.substr(0, fileEntry.nativeURL.lastIndexOf('/') + 1);
                        // Only copy because of access rights
                        $cordovaFile.copyFile(namePath, fileEntry.name, cordova.file.dataDirectory, newFileName).then(function (success) {
                            $scope.image = newFileName;
                        }, function (error) {
                            $scope.showAlert('Error', error.exception);
                        });
                    };
                }
              );
            } else {
                var namePath = imagePath.substr(0, imagePath.lastIndexOf('/') + 1);
                // Move the file to permanent storage
                $cordovaFile.moveFile(namePath, currentName, cordova.file.dataDirectory, newFileName).then(function (success) {
                    $scope.image = newFileName;
                }, function (error) {
                    $scope.showAlert('Error', error.exception);
                });
            }
        },
        function (err) {
            // Not always an error, maybe cancel was pressed...
        })
    };

    $scope.pathForImage = function (image) {
        if (image === null) {
            return '';
        } else {
            return cordova.file.dataDirectory + image;
        }
    };
    $scope.uploadImage = function () {
        // Destination URL
        var url = "http://ksazoo.com/breeze/zoo/upload";

        // File for Upload
        var targetPath = $scope.pathForImage($scope.image);

        // File name only
        var filename = $scope.image;

        var options = {
            fileKey: "file",
            fileName: filename,
            chunkedMode: false,
            mimeType: "multipart/form-data",
            params: { 'fileName': filename }
        };
        $ionicLoading.show({
            template: '<ion-spinner icon="lines"></ion-spinner>'
        });
        if ($scope.image) {
            $cordovaFileTransfer.upload(url, targetPath, options).then(function (result) {
                $ionicLoading.hide();
                if ($scope.isAr) {
                    $scope.showAlert('تم بنجاح', 'تم ارسال الاقتراح او الشكوى');
                } else {
                    $scope.showAlert('Success', 'Image upload finished.');
                }

                alert(result.data.join(""));
                var imageFile = result.data.join("");
                $http.get('http://ksazoo.com/breeze/mobile/AddFollowUp?userId=' + userId + '&suggestion=' + $scope.notes + '&image=' + imageFile + '&followupTypeId=' + $scope.value1)
                        .success(function (data) {
                            $scope.image = null;
                            $scope.notes = '';
                        })
                        .error(function (e) {
                            deferred.reject();
                            console.log('error');
                            $ionicLoading.hide();
                        });

            });
        } else {
            $http.get('http://ksazoo.com/breeze/mobile/AddFollowUp?userId=' + userId + '&suggestion=' + $scope.notes + '&followupTypeId=' + $scope.value1)
                        .success(function (data) {
                            $scope.image = null;
                            $scope.notes = '';
                        })
                        .error(function (e) {
                            deferred.reject();
                            console.log('error');
                            $ionicLoading.hide();
                        });
        }
    }
    $scope.checkRadio = function () {
        if ($scope.value1 == '3') {
            $scope.value1 = '2'
        } else {
            $scope.value1 = '3';
        }
    };
    $scope.sendProblem = function () {
        ////if ($scope.isLogged == false) {
        ////    if ($scope.isAr == true) {
        ////        $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
        ////    } else {
        ////        $scope.showAlert('Error', 'Please Login First.');
        ////    }
        ////    return;

        ////}
        //if (!$scope.image) {
        //    if ($scope.isAr == true) {

        //        $scope.showAlert('خطا', 'قم باختيار صورة');
        //    } else {
        //        $scope.showAlert('Error', 'Please Select Image.');
        //    }
        //    return;
        //}
        // Destination URL
        var url = "http://ksazoo.com/breeze/zoo/upload";

        // File for Upload
        var targetPath = $scope.pathForImage($scope.image);

        // File name only
        var filename = $scope.image;

        var options = {
            fileKey: "file",
            fileName: filename,
            chunkedMode: false,
            mimeType: "multipart/form-data",
            params: { 'fileName': filename }
        };
        $ionicLoading.show({
            template: '<ion-spinner icon="lines"></ion-spinner>'
        });
        if ($scope.image) {
            $cordovaFileTransfer.upload(url, targetPath, options).then(function (result) {
                var imageName = '';
                for (var i = 0; i < result.response.length; i++) {
                    if (result.response[i] == '\"' || result.response[i] == ',' || result.response[i] == ']' || result.response[i] == '[') {

                    } else {
                        imageName += result.response[i];
                    }

                }
                $http.get('http://ksazoo.com/breeze/mobile/AddFollowUp?userId=' + $scope.userId + '&type=' + $scope.value1 + '&suggestion=' + $scope.notes.data + '&complain=' + $scope.notes.data + '&image=' + imageName)
                        .success(function (data) {
                            //deferred.resolve(data);
                            // $scope.data = data;

                            $ionicLoading.hide();
                            if ($scope.isAr) {
                                $scope.showAlert('تم بنجاح', 'تم ارسال الاقتراح او الشكوى');
                            } else {
                                $scope.showAlert('Success', 'Image upload finished.');
                            }
                            $scope.pathForImage(null);
                            $scope.image = null;
                            $scope.$broadcast('scroll.refreshComplete');
                            $scope.name.data = '';
                            $scope.mobile.data = '';
                            $scope.mail.data = '';
                            $scope.notes.data = '';
                            // sqlite



                            //end sqlite
                        })
                        .error(function (e) {
                            //deferred.reject();
                            console.log('error');
                            $ionicLoading.hide();
                            $scope.$broadcast('scroll.refreshComplete');

                        });
                //$ionicLoading.hide();

                //alert(result.data.join(""));
            });
        } else {
            $http.get('http://ksazoo.com/breeze/mobile/AddFollowUp?userId=' + $scope.userId + '&type=' + $scope.value1 + '&suggestion=' + $scope.notes.data + '&complain=' + $scope.notes.data)
                        .success(function (data) {
                            //deferred.resolve(data);
                            // $scope.data = data;
                            $ionicLoading.hide();
                            if ($scope.isAr) {
                                $scope.showAlert('تم بنجاح', 'تم ارسال الاقتراح او الشكوى');
                            } else {
                                $scope.showAlert('Success', 'Image upload finished.');
                            }
                            $scope.pathForImage(null);
                            $scope.image = null;
                            $scope.$broadcast('scroll.refreshComplete');
                            $scope.name.data = '';
                            $scope.mobile.data = '';
                            $scope.mail.data = '';
                            $scope.notes.data = '';
                            // sqlite



                            //end sqlite
                        })
                        .error(function (e) {
                            //deferred.reject();
                            console.log('error');
                            $ionicLoading.hide();
                            $scope.$broadcast('scroll.refreshComplete');

                        });
            //$ionicLoading.hide();
        }
       
    };

    $scope.getUser = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            //tx.executeSql('DROP TABLE IF EXISTS UserData');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
    $scope.showConfirm = function () {
        var confirmPopup = $ionicPopup.confirm({
            title: 'Consume Ice Cream',
            template: 'Are you sure you want to eat this ice cream?'
        });

        confirmPopup.then(function (res) {
            if (res) {
                $state.go('tab.newpost');
                console.log('You are sure');
            } else {
                console.log('You are not sure');
            }
        });
    };

});