app.controller('VisitorRequestCtrl', function ($state, $scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite, ionicDatePicker, $cordovaCamera, $cordovaFile, $cordovaFileTransfer, $cordovaDevice, $ionicPopup, $cordovaActionSheet) {
    //ionic.material.ink.displayEffect();
    $scope.name = {};
    $scope.mobile = {};
    $scope.mail = {};
    $scope.notes = {};
    $scope.organizationName = {};
    $scope.managerName = {};
    $scope.visitorsNumber = {};
    $scope.supervisorNumber = {};
    $scope.data = [];
    $scope.visitorDay = '';
    $scope.visitorRequest = '';
    $scope.sendRequest = '';
    $scope.isAr = false;
    $scope.Name = 'Name of Institution';
    $scope.Mobile = 'Mobile';
    $scope.Email = 'Email';
    $scope.Note = 'Note';
    $scope.OrganizationName = 'Organization Name';
    $scope.ManagerName = 'Manager Name';
    $scope.VisitorsNumber = 'Visitors Number';
    $scope.AddRequest = '';
    $scope.SupervisorNumber = 'Supervisors Number';

    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;
    $scope.year = null;
    $scope.month = null;
    $scope.day = null;
    $scope.dates = [];
    $scope.orgs = [];
    $scope.selectedOrg = null;
    $scope.orgId = null;
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.$on('$ionicView.enter', function () {
      $ionicLoading.show({
        template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
      });
        // code to run each time view is entered
      $http.get('http://ksazoo.com/breeze/mobile/GetOrganizationCategories')
        .success(function (data) {
          $scope.orgs = data;
          $ionicLoading.hide();

        })
        .error(function (e) {
          $ionicLoading.hide();
        });
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.visitorDay = 'visitor Day';
            $scope.visitorRequest = 'visitor Request';
            $scope.sendRequest = 'Send Request';
            $scope.Name = 'Name';
            $scope.Mobile = 'Mobile';
            $scope.Email = 'Email';
            $scope.Note = 'Note';
            $scope.AddRequest = 'Upload Request';
            $scope.OrganizationName = 'Organization Name';
            $scope.ManagerName = 'Manager Name';
            $scope.VisitorsNumber = 'Visitors Number Only Number';
            $scope.SupervisorNumber = 'Supervisors Number';
        } else {
            $scope.isAr = true;
            $scope.visitorDay = 'يوم الزيارة';
            $scope.visitorRequest = 'طلب زيارة';
            $scope.sendRequest = 'ارسال طلب';
            $scope.Name = 'اسم';
            $scope.Mobile = 'الجوال';
            $scope.Email = 'الايميل';
            $scope.Note = 'ملاحظات';
            $scope.AddRequest = 'رفع الطلب';
            $scope.OrganizationName = 'اسم المنظمة';
            $scope.ManagerName = 'اسم المسئول';
            $scope.VisitorsNumber = 'عدد الزوار يقبل ارقام فقط';
            $scope.SupervisorNumber = 'عدد المشرفين';
        }
        $scope.getUser();
    });
    $scope.selectedDate1;
    $scope.openDatePickerOne = function (val) {
        var ipObj1 = {
            callback: function (val) {  //Mandatory
                console.log('Return value from the datepicker popup is : ' + val, new Date(val));
                $scope.selectedDate1 = new Date(val).toLocaleDateString();
                $scope.month = new Date(val).getMonth()+1;
                $scope.day = new Date(val).getDate();
                $scope.year = new Date(val).getFullYear();
            },
            disabledDates: [
              new Date(2016, 2, 16),
              new Date(2015, 3, 16),
              new Date(2015, 4, 16),
              new Date(2015, 5, 16),
              new Date('Wednesday, August 12, 2015'),
              new Date("08-16-2016"),
              new Date(1439676000000)
            ],
            from: new Date(2012, 1, 1),
            to: new Date(2030, 10, 30),
            inputDate: new Date(),
            mondayFirst: true,
            disableWeekdays: [],
            closeOnSelect: false,
            templateType: 'popup'
        };
        ionicDatePicker.openDatePicker(ipObj1);
    };
    $scope.image = null;
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
    $scope.sendVisitRequest = function () {
        if ($scope.isLogged == true) {
            if (!$scope.year) {
                if ($scope.isAr)
                    $scope.showAlert('التاريح', 'قم بادخال التاريخ')
                else
                    $scope.showAlert('Visit Date', 'Please Insert visit Date')
                return false;
            }
            if ($scope.image && $scope.image != '') {
                
                var url = "http://ksazoo.com/breeze/zoo/upload";

                // File for Upload
                var targetPath = $scope.pathForImage($scope.image);

                // File name only
                var filename = $scope.image;

                var options = {
                    fileKey: "file",
                    fileName: filename,
                    chunkedMode: false,
                    mimeType: "multipart/form-data",
                    params: { 'fileName': filename }
                };
                $ionicLoading.show({
                    template: '<ion-spinner icon="lines"></ion-spinner>'
                });
                //$ionicLoading.show({
                //    template: '<ion-spinner icon="lines"></ion-spinner>'
                //});
                //alert($scope.name.data);
                //alert($scope.selectedDate1);
                $cordovaFileTransfer.upload(url, targetPath, options).then(function (result) {
                    //$ionicLoading.hide();
                    //if ($scope.isAr) {
                    //    $scope.showAlert('تم بنجاح', 'تم ارسال  طلبك بنجاح ');
                    //} else {
                    //    $scope.showAlert('Success', 'Visit Request Send Succesfully');
                    //}
                    //alert(result.data.join(""));
                    var imageName = '';
                    //alert(JSON.stringify(result));
                    //alert(JSON.stringify(result.response));
                    for (var i = 0; i < result.response.length; i++) {
                        if (result.response[i] == '\"' || result.response[i] == ',' || result.response[i] == ']' || result.response[i] == '[') {

                        } else {
                            imageName += result.response[i];
                        }
                        //alert(result.response[i].toString())

                    }
                    //alert($scope.orgId);
                    $http.get('http://ksazoo.com/breeze/mobile/AddVisitRequest?userId=' + $scope.userId + '&year='
                        + $scope.year + '&month=' + $scope.month + '&day=' + $scope.day + '&requesterName='
                        + $scope.name.data + '&requesterMobile=' + $scope.mobile.data + '&requesterEmail='
                      + $scope.mail.data + '&Notes=' + $scope.notes.data + '&MainFile=' + imageName
                      + '&organizationName=' + $scope.organizationName.data
                      + '&managerName=' + $scope.managerName.data
                      + '&visitorsNumber=' + $scope.visitorsNumber.data
                      + '&supervisorsNumber' + $scope.supervisorNumber.data
                      + '&organizationCategoryId=' + $scope.orgId)
                                .success(function (data) {
                                    if ($scope.isAr) {
                                        $scope.showAlert('تم بنجاح', 'تم ارسال  طلبك بنجاح ');
                                    } else {
                                        $scope.showAlert('Success', 'Visit Request Send Succesfully');
                                    }
                                    $ionicLoading.hide();
                                    $scope.name.data = '';
                                    $scope.mobile.data = '';
                                    $scope.mail.data = '';
                                    $scope.notes.data = '';
                                    $scope.selectedDate1 = null;
                                    $scope.image = null;

                                })
                                .error(function (e) {
                                    if ($scope.isAr) {
                                        $scope.showAlert(' خطا', 'خطا فى ارسال الطلب');
                                    } else {
                                        $scope.showAlert('Error', 'Error Request Send');
                                    }
                                    
                                    $ionicLoading.hide();
                                    //deferred.reject();
                                    console.log('error');

                                    $scope.name.data = '';
                                    $scope.mobile.data = '';
                                    $scope.mail.data = '';
                                    $scope.notes.data = '';
                                    $scope.selectedDate1 = null;
                                });
                });
            } else {
                $http.get('http://ksazoo.com/breeze/mobile/AddVisitRequest?userId=' + $scope.userId + '&year='
                        + $scope.year + '&month=' + $scope.month + '&day=' + $scope.day
                        + '&requesterName=' + $scope.name.data + '&requesterMobile='
                        + $scope.mobile.data + '&requesterEmail=' + $scope.mail.data
                        + '&Notes=' + $scope.notes.data
                        + '&OrganizationName=' + $scope.organizationName.data
                  + '&ManagerName=' + $scope.managerName.data
                  + '&VisitorsNumber=' + $scope.visitorsNumber.data
                        + '&SuperVisorNumber' + $scope.supervisorNumber.data
                        + '&organizationCategoryId=' + $scope.orgId)
                                .success(function (data) {
                                    if ($scope.isAr) {
                                        $scope.showAlert('تم بنجاح', 'تم ارسال  طلبك بنجاح ');
                                    } else {
                                        $scope.showAlert('Success', 'Visit Request Send Succesfully');
                                    }
                                    $ionicLoading.hide();
                                    $scope.name.data = '';
                                    $scope.mobile.data = '';
                                    $scope.mail.data = '';
                                    $scope.notes.data = '';
                                    $scope.selectedDate1 = null;
                                    $scope.image = null;

                                })
                                .error(function (e) {
                                    if ($scope.isAr) {
                                        $scope.showAlert(' خطا', 'خطا فى ارسال الطلب');
                                    } else {
                                        $scope.showAlert('Error', 'Error Request Send');
                                    }
                                    $ionicLoading.hide();
                                    //deferred.reject();
                                    console.log('error');

                                    $scope.name.data = '';
                                    $scope.mobile.data = '';
                                    $scope.mail.data = '';
                                    $scope.notes.data = '';
                                    $scope.selectedDate1 = null;
                                });
            }
        } else {
            if ($scope.isAr) {
                $scope.showConfirm('تسجيل الدخول', 'من فضلك قم بتسجيل الدخول');
            }
            else {
                $scope.showConfirm('Login Please ..', 'Please Login or register');
            }
            //$scope.showAlert('Warning', 'Please Login First');
        }
    };
    $scope.getUser = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            //tx.executeSql('DROP TABLE IF EXISTS UserData');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };


    $scope.loadImage = function () {
        if ($scope.isLogged == false) {
            if ($scope.isAr == true) {
                $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
            } else {
                $scope.showAlert('Error', 'Please Login First.');
            }
            return;
        }
        var options = {
            title: 'Select Image Source',
            buttonLabels: ['Load from Library', 'Use Camera'],
            addCancelButtonWithLabel: 'Cancel',
            androidEnableCancelButton: true,
        };
        $cordovaActionSheet.show(options).then(function (btnIndex) {
            var type = null;
            if (btnIndex === 1) {
                type = Camera.PictureSourceType.PHOTOLIBRARY;
            } else if (btnIndex === 2) {
                type = Camera.PictureSourceType.CAMERA;
            }
            if (type !== null) {
                $scope.selectPicture(type);
            }
        });
    };










    $scope.selectPicture = function (sourceType) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: sourceType,
            saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imagePath) {
            // Grab the file name of the photo in the temporary directory
            var currentName = imagePath.replace(/^.*[\\\/]/, '');

            //Create a new name for the photo
            var d = new Date(),
            n = d.getTime(),
            newFileName = n + ".jpg";

            // If you are trying to load image from the gallery on Android we need special treatment!
            if ($cordovaDevice.getPlatform() == 'Android' && sourceType === Camera.PictureSourceType.PHOTOLIBRARY) {
                window.FilePath.resolveNativePath(imagePath, function (entry) {
                    window.resolveLocalFileSystemURL(entry, success, fail);
                    function fail(e) {
                        console.error('Error: ', e);
                    }

                    function success(fileEntry) {
                        var namePath = fileEntry.nativeURL.substr(0, fileEntry.nativeURL.lastIndexOf('/') + 1);
                        // Only copy because of access rights
                        $cordovaFile.copyFile(namePath, fileEntry.name, cordova.file.dataDirectory, newFileName).then(function (success) {
                            $scope.image = newFileName;
                        }, function (error) {
                            $scope.showAlert('Error', error.exception);
                        });
                    };
                }
              );
            } else {
                var namePath = imagePath.substr(0, imagePath.lastIndexOf('/') + 1);
                // Move the file to permanent storage
                $cordovaFile.moveFile(namePath, currentName, cordova.file.dataDirectory, newFileName).then(function (success) {
                    $scope.image = newFileName;
                }, function (error) {
                    $scope.showAlert('Error', error.exception);
                });
            }
        },
        function (err) {
            // Not always an error, maybe cancel was pressed...
        })
    };

    $scope.pathForImage = function (image) {
        if (image === null) {
            return '';
        } else {
            return cordova.file.dataDirectory + image;
        }
    };
    $scope.showConfirm = function (title,template) {
        var confirmPopup = $ionicPopup.confirm({
            title: title,
            template: template ,
            //buttons: [{ text: 'Ok', type: 'button-positive' }, { text: 'Cancel' }]

        });

        confirmPopup.then(function (res) {
            if (res) {
                $state.go('app.loginlist');
                console.log('You are sure');
            } else {
                console.log('You are not sure');
            }
        });
    };
    $scope.changeOrg = function (data) {
      if (data) {
        //alert(data);
        //alert(data.ID);
        $scope.orgId = data.ID;
      } else {
        $scope.orgId = null;
      }
    }
    
});




