﻿app.controller('AboutCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.isAr = false;
    $scope.Title = '';
    $scope.data = {};
    $scope.getData = function () {
        //var db = $cordovaSQLite.openDB({ name: "rdyzoo.db" });
        //alert('test');
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }

        $scope.data = {};
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS CompanyProfile (ID, CompanyName,CompanyNameAr,Disclaimer,DisclaimerAr,MainImage,MainVideo,AboutCompany,AboutCompanyAr,AboutApp,AboutAppAr)');
            tx.executeSql('SELECT * FROM CompanyProfile', [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    //for (var i = 0; i < rs.rows.length; i++) {
                        $scope.data = {
                            ID: rs.rows.item(0).ID, CompanyName: rs.rows.item(0).CompanyName, CompanyNameAr: rs.rows.item(0).CompanyNameAr,
                            Disclaimer: rs.rows.item(0).Disclaimer, DisclaimerAr: rs.rows.item(0).DisclaimerAr, MainImage: rs.rows.item(0).MainImage,
                            MainVideo: rs.rows.item(0).MainVideo, AboutCompany: rs.rows.item(0).AboutCompany, AboutCompanyAr: rs.rows.item(0).AboutCompanyAr, AboutApp: rs.rows.item(0).AboutApp, AboutAppAr: rs.rows.item(0).AboutAppAr

                        };
                    //}
                    $ionicLoading.hide();
                } else {
                    $http.get('http://ksazoo.com/breeze/mobile/GetCompanyProfile')
                    .success(function (data) {
                        db.transaction(function (tx) {
                            //data.forEach(function (item) {
                            $ionicLoading.hide();
                            tx.executeSql('INSERT INTO CompanyProfile VALUES (?,?,?,?,?,?,?,?,?,?,?)', [data.ID, data.CompanyName, data.CompanyNameAr,
                                    data.Disclaimer, data.DisclaimerAr,
                                    data.MainImage, data.MainVideo, data.AboutCompany, data.AboutCompanyAr, data.AboutApp, data.AboutAppAr]);
                            //});
                            tx.executeSql('SELECT * FROM CompanyProfile', [], function (tx, rs) {
                                for (var i = 0; i < rs.rows.length; i++) {
                                    $scope.data = {
                                        ID: rs.rows.item(0).ID, CompanyName: rs.rows.item(0).CompanyName, CompanyNameAr: rs.rows.item(0).CompanyNameAr,
                                        Disclaimer: rs.rows.item(0).Disclaimer, DisclaimerAr: rs.rows.item(0).DisclaimerAr, MainImage: rs.rows.item(0).MainImage,
                                        MainVideo: rs.rows.item(0).MainVideo, AboutCompany: rs.rows.item(0).AboutCompany, AboutCompanyAr: rs.rows.item(0).AboutCompanyAr, AboutApp: rs.rows.item(0).AboutApp, AboutAppAr: rs.rows.item(0).AboutAppAr

                                    };
                                }

                            });
                            
                            


                        }, function (error) {
                            alert('Transaction ERROR: ' + error.message);
                            $ionicLoading.hide();
                        }, function () {
                            //alert('Populated database OK');

                        });

                        //deferred.resolve(data);
                        // $scope.data = data;
                        
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
            });
        });




    };
    //ionic.material.ink.displayEffect();

    
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'About Zoo';
        } else {
            $scope.isAr = true;
            $scope.Title = 'عن الحديقة';
        }
        $scope.getData();
    });
});