﻿app.controller('CompetitionDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite, $cordovaCamera, $cordovaFile, $cordovaFileTransfer, $cordovaDevice, $ionicPopup, $cordovaActionSheet) {
    //ionic.material.ink.displayEffect();
    $scope, data = null;
    $scope.isAr = false;
    $scope.addC = false;
    $scope.comment = {};
    $scope.addImage = null;
    $scope.uploadImageText = null;

    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;



    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.addImage = 'Add Image';
            $scope.uploadImageText = 'Upload Image';
        } else {
            $scope.isAr = true;
            $scope.addImage = 'اضافة صورة';
            $scope.uploadImageText = 'تحميل الصورة';
        }
        $scope.getUser();
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        }
    });
    $scope.getData = function (Id) {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        var deferred = $q.defer()

        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM Competation where ID = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    $scope.data = {
                        ID: rs.rows.item(0).ID,
                        Name: rs.rows.item(0).Name,
                        NameAr: rs.rows.item(0).NameAr,
                        Description: rs.rows.item(0).Description,
                        DescriptionAr: rs.rows.item(0).DescriptionAr,
                        MainImage: rs.rows.item(0).MainImage,
                        MainVideo: rs.rows.item(0).MainVideo,
                        AnimalTypeName: rs.rows.item(0).AnimalTypeName
                    };
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        //$http.get('http://ksazoo.com/breeze/mobile/getAnimalDetails?Id=' + Id)
        //.success(function (data) {
        //    deferred.resolve(data);
        //    $scope.data = data;
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //})
        //.error(function (e) {
        //    deferred.reject();
        //    console.log('error');
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //});
        //$scope.data = deferred.promise;
    };
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/ionic.png'
        }
    };
    
    $scope.addComment = function () {
        if ($scope.addC == false) {
            $scope.addC = true;
        } else {
            $scope.addC = false;
        }
    };
    $scope.sendComment = function () {

    };


    $scope.image = null;
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };


    $scope.loadImage = function () {
        if ($scope.isLogged == false) {
            if ($scope.isAr == true) {
                $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
            } else {
                $scope.showAlert('Error', 'Please Login First.');
            }
            return;
        }
        var options = {
            title: 'Select Image Source',
            buttonLabels: ['Load from Library', 'Use Camera'],
            addCancelButtonWithLabel: 'Cancel',
            androidEnableCancelButton: true,
        };
        $cordovaActionSheet.show(options).then(function (btnIndex) {
            var type = null;
            if (btnIndex === 1) {
                type = Camera.PictureSourceType.PHOTOLIBRARY;
            } else if (btnIndex === 2) {
                type = Camera.PictureSourceType.CAMERA;
            }
            if (type !== null) {
                $scope.selectPicture(type);
            }
        });
    };


    $scope.selectPicture = function (sourceType) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: sourceType,
            saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imagePath) {
            // Grab the file name of the photo in the temporary directory
            var currentName = imagePath.replace(/^.*[\\\/]/, '');

            //Create a new name for the photo
            var d = new Date(),
            n = d.getTime(),
            newFileName = n + ".jpg";

            // If you are trying to load image from the gallery on Android we need special treatment!
            if ($cordovaDevice.getPlatform() == 'Android' && sourceType === Camera.PictureSourceType.PHOTOLIBRARY) {
                window.FilePath.resolveNativePath(imagePath, function (entry) {
                    window.resolveLocalFileSystemURL(entry, success, fail);
                    function fail(e) {
                        console.error('Error: ', e);
                    }

                    function success(fileEntry) {
                        var namePath = fileEntry.nativeURL.substr(0, fileEntry.nativeURL.lastIndexOf('/') + 1);
                        // Only copy because of access rights
                        $cordovaFile.copyFile(namePath, fileEntry.name, cordova.file.dataDirectory, newFileName).then(function (success) {
                            $scope.image = newFileName;
                        }, function (error) {
                            $scope.showAlert('Error', error.exception);
                        });
                    };
                }
              );
            } else {
                var namePath = imagePath.substr(0, imagePath.lastIndexOf('/') + 1);
                // Move the file to permanent storage
                $cordovaFile.moveFile(namePath, currentName, cordova.file.dataDirectory, newFileName).then(function (success) {
                    $scope.image = newFileName;
                }, function (error) {
                    $scope.showAlert('Error', error.exception);
                });
            }
        },
        function (err) {
            // Not always an error, maybe cancel was pressed...
        })
    };

    $scope.pathForImage = function (image) {
        if (image === null) {
            return '';
        } else {
            return cordova.file.dataDirectory + image;
        }
    };
    $scope.uploadImage = function () {
        if ($scope.isLogged == false) {
            if ($scope.isAr == true) {
                $scope.showAlert('خطا', 'من فضلك تسجيل الدخول');
            } else {
                $scope.showAlert('Error', 'Please Login First.');
            }
            return;

        }
        if (!$scope.image) {
            if ($scope.isAr == true) {
                $scope.showAlert('خطا', 'قم باختيار صورة');
            } else {
                $scope.showAlert('Error', 'Please Select Image.');
            }
            return;
        }
        // Destination URL
        var url = "http://ksazoo.com/breeze/zoo/upload";

        // File for Upload
        var targetPath = $scope.pathForImage($scope.image);

        // File name only
        var filename = $scope.image;

        var options = {
            fileKey: "file",
            fileName: filename,
            chunkedMode: false,
            mimeType: "multipart/form-data",
            params: { 'fileName': filename }
        };
        $ionicLoading.show({
            template: '<ion-spinner icon="lines"></ion-spinner>'
        });
        $cordovaFileTransfer.upload(url, targetPath, options).then(function (result) {
            var imageName = '';
            //alert(JSON.stringify(result));
            //alert(JSON.stringify(result.response));
            for(var i=0;i<result.response.length;i++)
            {
                if (result.response[i] == '\"' || result.response[i] == ',' || result.response[i] == ']' || result.response[i] == '[') {

                } else {
                    imageName += result.response[i];
                }
                //alert(result.response[i].toString())
                
            }
            //.forEach(function (item) {
            //    alert(item);
            //    imageName += item.toString();
            //});

            //alert(imageName);
            //alert($scope.userId);
            $http.get('http://ksazoo.com/breeze/mobile/AddCompetitionAnswer?competitionId=' + $stateParams.ID + '&userId=' + $scope.userId + '&file=' + imageName)
                    .success(function (data) {
                        //deferred.resolve(data);
                        // $scope.data = data;
                        $ionicLoading.hide();
                        $scope.showAlert('Success', 'Image upload finished.');
                        $scope.pathForImage(null);
                        $scope.image = null;
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });
            $ionicLoading.hide();
            
            //alert(result.data.join(""));
        });
    }

    $scope.getUser = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            //tx.executeSql('DROP TABLE IF EXISTS UserData');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
    };
});