﻿app.controller('HomeCtrl', function ($scope, $stateParams, ionicMaterialInk, $cordovaSQLite, $cordovaOauth, $ionicLoading, $q, $http) {
    //ionic.material.ink.displayEffect();
    $scope.Home = '';
    $scope.Animals = '';
    $scope.News = '';
    $scope.Ticket = '';
    $scope.Vistores = '';
    $scope.InternalMap = '';
    $scope.OutSideMap = '';
    $scope.About = '';
    $scope.ServiceCategory = '';
    $scope.VideoImage = '';
    $scope.VisitRequest = '';
    $scope.Suggestation = '';
    $scope.Questionnaire = 'Aquestionnaire';
    $scope.Settings = '';
    $scope.DeleteCookiesTitle = '';
    $scope.TwitterLoginTitle = '';
    $scope.Login = '';
    $scope.isAr = false;
    var twitterKey = "STORAGE.TWITTER.KEY";
    var clientId = 'SBUTOpjSsVl8yfIqtLiEueLY0';
    var clientSecret = 'SWHJId9Z5EQVDKZpwuzTQWcOPZsk3nFESUcOz3zZXpnB3l2PwR';
    
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.langName = "En";
            $scope.Home = 'Home';
            $scope.Animals = 'Animals';
            $scope.News = 'News';
            $scope.Ticket = 'Ticket';
            $scope.Vistores = 'Vistores';
            $scope.InternalMap = 'Internal Map';
            $scope.OutSideMap = 'OutSide Map';
            $scope.About = 'About';
            $scope.ServiceCategory = 'Services & Cafe & Resturant';
            $scope.VideoImage = 'Videos and Images';
            $scope.VisitRequest = 'Visit Request';
            $scope.Suggestation = 'Complaints proposals';
            $scope.Competitions = 'Competitions';
            $scope.knowledge = 'Zoo Knowledge';
            $scope.Questionnaire = 'Aquestionnaire';
            $scope.Settings = 'Settings';
            $scope.DeleteCookies = 'Delete Cookies';
            $scope.TwitterLogin = 'Twitter Login';
            $scope.Login = 'Login & Twitter Login';

        } else {
            $scope.isAr = true;
            $scope.langName = "العربية";
            $scope.Home = 'الرئيسية';
            $scope.Animals = 'الحيوانات';
            $scope.News = 'الاخبار';
            $scope.Ticket = 'التذاكر';
            $scope.Vistores = 'الزوار';
            $scope.InternalMap = 'الخريطة الداخلية';
            $scope.OutSideMap = 'الخريطة الخارجية';
            $scope.About = 'عن التطبيق';
            $scope.ServiceCategory = 'الخدمات';
            $scope.VideoImage = 'معرض الفيديوهات و الصور';
            $scope.VisitRequest = 'طلب زيارة';
            $scope.Suggestation = 'الشكاوى و المقترحات';
            $scope.Competitions = 'المسابقات';
            $scope.knowledge = 'التعريف بالحديقة';
            $scope.Questionnaire = 'استبيان';
            $scope.Settings = 'الاعدادات';
            $scope.DeleteCookiesTitle = 'مسح البيانات';
            $scope.TwitterLoginTitle = 'التسجيل بتويتر';
            $scope.Login = 'تسجيل الدخول';
        }
        $scope.getData();

    });
    $scope.deleteCookies = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('DROP TABLE IF EXISTS Animal');
            tx.executeSql('DROP TABLE IF EXISTS Events');
            tx.executeSql('DROP TABLE IF EXISTS EventNews');
            tx.executeSql('DROP TABLE IF EXISTS EventNewsImage');
            tx.executeSql('DROP TABLE IF EXISTS Ticket');
            tx.executeSql('DROP TABLE IF EXISTS ServicesCategory');
            tx.executeSql('DROP TABLE IF EXISTS Services');
            tx.executeSql('DROP TABLE IF EXISTS Menus');
            tx.executeSql('DROP TABLE IF EXISTS MenuItems');
            tx.executeSql('DROP TABLE IF EXISTS TicketType');
            tx.executeSql('DROP TABLE IF EXISTS Ticket');
            tx.executeSql('DROP TABLE IF EXISTS Vistor');
            tx.executeSql('DROP TABLE IF EXISTS VistorType');
            tx.executeSql('DROP TABLE IF EXISTS VistorDay');
            alert('Drop Done');
        });
    };
    $scope.getData = function () {
        //var db = $cordovaSQLite.openDB({ name: "rdyzoo.db" });
        //alert('test');
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }

        $scope.data = {};
        //$ionicLoading.show({
        //    template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        //});
        var deferred = $q.defer();
        db.transaction(function (tx) {

            //tx.executeSql('DELETE FROM Animals ');
            //tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('CREATE TABLE IF NOT EXISTS CompanyProfile (ID, CompanyName,CompanyNameAr,Disclaimer,DisclaimerAr,MainImage,MainVideo,AboutCompany,AboutCompanyAr,AboutApp,AboutAppAr)');
            tx.executeSql('SELECT * FROM CompanyProfile', [], function (tx, rs) {
                if (rs.rows.length <= 0) {
                    $http.get('http://ksazoo.com/breeze/mobile/GetCompanyProfile')
                    .success(function (data) {
                        db.transaction(function (tx) {
                            //data.forEach(function (item) {
                            $ionicLoading.hide();
                            tx.executeSql('INSERT INTO CompanyProfile VALUES (?,?,?,?,?,?,?,?,?,?,?)', [data.ID, data.CompanyName, data.CompanyNameAr,
                                    data.Disclaimer, data.DisclaimerAr,
                                    data.MainImage, data.MainVideo, data.AboutCompany, data.AboutCompanyAr, data.AboutApp, data.AboutAppAr]);
                            //});





                        }, function (error) {
                            alert('Transaction ERROR: ' + error.message);
                            $ionicLoading.hide();
                        }, function () {

                        });
                    })
                    .error(function (e) {
                        $ionicLoading.hide();

                    });
                    $ionicLoading.hide();
                } else {
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
            });
        });




    };
    
    $scope.twitterLogin = function () {
        $cordovaOauth.twitter("SBUTOpjSsVl8yfIqtLiEueLY0", 'SWHJId9Z5EQVDKZpwuzTQWcOPZsk3nFESUcOz3zZXpnB3l2PwR', { redirect_uri: "http://10.0.2.2/callback" }).then(function (result) {
            alert('ok111');
            alert(JSON.stringify(result));
        }, function (error) {
            alert(JSON.stringify(error));
        });
        //alert('test');
    }

});