app.controller('LoginListCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite, $cordovaOauth) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.isAr = false;
    $scope.logByApp = false;
    $scope.registerByApp = false;
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.Name = {};
    $scope.password = {};
    //translate
    $scope.loginListTitle = '';
    $scope.loginTitle = '';
    $scope.logouTtitle = '';
    $scope.RegisterAppTitle = '';
    $scope.LoginAppTitle = '';
    $scope.LoginTwitterTitle = '';

    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.twitterLoginFinal = {};
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        $timeout(function () {
            if (document.cookie == "zooWeb=en") {
                $scope.isAr = false;
                $scope.loginListTitle = 'Login List';
                $scope.loginTitle = 'Login';
                $scope.logouTtitle = 'LouOut';
                $scope.RegisterAppTitle = 'Register App';
                $scope.LoginAppTitle = 'Login App';
                $scope.LoginTwitterTitle = 'Login Twitter';
                
            } else {
                $scope.isAr = true;
                $scope.loginListTitle = 'تسجيل دخول';
                $scope.loginTitle = 'دخول';
                $scope.logouTtitle = 'تسجيل خروج';
                $scope.RegisterAppTitle = 'تسجيل التطبيق';
                $scope.LoginAppTitle = 'دخول التطبيق';
                $scope.LoginTwitterTitle = 'دخول تويتر';
                
            }
            var db = null;
            // for opening a background db:
            if (window.cordova) {
                db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
                //alert("Android");
            } else {
                db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
                //alert("browser");

            }
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        },100);
    });
    $scope.userLoginApp = function () {
        if ($scope.logByApp == false) {
          $scope.logByApp = true;
          $scope.registerByApp = false;
        } else {
            $scope.logByApp = false;
        }
    };
    $scope.userRegisterApp = function () {
        if ($scope.registerByApp == false) {
          $scope.registerByApp = true;
          $scope.logByApp = false;
        } else {
            $scope.registerByApp = false;
        }
    };
    $scope.device = '';
    $scope.token = '';
    $scope.getTokenData = function () {
      
      window.FirebasePlugin.getToken(function (token) {
        // save this server-side and use it to push notifications to this device
        //alert(token);
        $scope.token = token;
        //alert(window.navigator.platform);
        if ($ionicPlatform.is('android')) {
          //alert("Android device");
          $scope.device = 'android';
        }

        if ($ionicPlatform.is('ios')) {
          // alert("iOS device");
          $scope.device = 'ios';
        }
      }, function (error) {
        alert(error);
      });
    }
    $scope.getTokenData();
    $scope.twitterKey = "STORAGE.TWITTER.KEY";
    $scope.clientId = 'SBUTOpjSsVl8yfIqtLiEueLY0';
    $scope.clientSecret = 'SWHJId9Z5EQVDKZpwuzTQWcOPZsk3nFESUcOz3zZXpnB3l2PwR';
    $scope.twitterLogin = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        $cordovaOauth.twitter("SBUTOpjSsVl8yfIqtLiEueLY0", 'SWHJId9Z5EQVDKZpwuzTQWcOPZsk3nFESUcOz3zZXpnB3l2PwR').then(function (result) {
            //alert('ok111');
            //$ionicLoading.hide();
            //alert(JSON.stringify(result));
            $scope.twitterLoginFinal = result;
            //alert($scope.twitterLoginFinal.user_id);
            //alert($scope.twitterLogin.screen_name);
            $timeout(function () {
                var db = null;
                // for opening a background db:
                if (window.cordova) {
                    db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
                    //alert("Android");
                } else {
                    db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
                    //alert("browser");

                }
                db.transaction(function (tx) {
                    //alert($scope.twitterLoginFinal.screen_name);
                    tx.executeSql('DROP TABLE IF EXISTS UserData');
                    $http.get('http://ksazoo.com/breeze/mobile/LoginTWUser?user_id_tw=' + $scope.twitterLoginFinal.user_id + '&device=' + $scope.device + '&token=' + $scope.token)
                    .success(function (data) {
                        //alert(data);
                        $ionicLoading.hide();
                        db.transaction(function (tx) {
                            $scope.showAlert('Success', 'User Logged By Twitter');
                            //alert(JSON.stringify(data));
                            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                            tx.executeSql('INSERT INTO UserData VALUES (?,?,?,?,?)', [data.ID.toString(), $scope.twitterLoginFinal.user_id, $scope.twitterLoginFinal.screen_name, '123456', 'twitter']);
                            $ionicLoading.hide();
                            $scope.isLogged = true;
                            $scope.logByApp = false;
                            $scope.registerByApp = false;
                        });
                        
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function (e) {
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                        $scope.showAlert('Error', 'User Logged By Twitter');

                    });
                    
                    $scope.isLogged = true;
                    //alert('Twitter Registered');
                });
            },100);


        }, function (error) {
            $ionicLoading.hide();
            $scope.showAlert('Error', JSON.stringify(error));
            //alert(JSON.stringify(error));
        });
        //alert('test');
    }
    $scope.registerApp = function () {
      $ionicLoading.show({
        template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
      });
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        
            
        $http.get('http://ksazoo.com/breeze/mobile/CreateUser?userName=' + $scope.Name.data + '&password=' + $scope.password.data + '&roleId=2' + '&email=' + 'test' + '&mobile=' + '&active=' + true + '&device=' + $scope.device + '&token=' + $scope.token)
              .success(function (data) {
                $ionicLoading.hide();
                        //deferred.resolve(data);
                        db.transaction(function (tx) {
                                tx.executeSql('DROP TABLE IF EXISTS UserData');
                                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                                tx.executeSql('INSERT INTO UserData VALUES (?,?,?,?,?)', [data.ID,'1', $scope.Name.data, $scope.password.data, 'normal']);
                        // $scope.data = data;
                        });
                        $scope.isLogged = true;
                        $scope.logByApp = false;
                        $scope.registerByApp = false;
                        $scope.
                        $scope.showAlert('Success', 'User Logged');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        //deferred.reject();
                        $scope.showAlert('Error', 'User Logged');
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');

                    });
        
    };
    $scope.loginApp = function () {
      $ionicLoading.show({
        template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
      });
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }

        $http.get('http://ksazoo.com/breeze/mobile/Login?userName=' + $scope.Name.data + '&password=' + $scope.password.data + '&device=' + $scope.device + '&token=' + $scope.token)
              .success(function (data) {
                $ionicLoading.hide();
                        if (data == false) {
                            $scope.isLogged = false;
                            if ($scope.isAr == true) {
                                $scope.showAlert('خطا', 'الاسم او الرقم السرى خطا');
                            } else {
                                $scope.showAlert('Error', 'Wrong User Name Or Password.');
                            }
                            return;
                            $scope.Name.data = '';
                            $scope.password.data = '';
                        }
                        db.transaction(function (tx) {
                                tx.executeSql('DROP TABLE IF EXISTS UserData');
                                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                                tx.executeSql('INSERT INTO UserData VALUES (?,?,?,?,?)', [data.ID, null, $scope.Name.data, $scope.password.data, 'normal']);
                                $scope.Name.data = '';
                                $scope.password.data = '';
                        });
                        // $scope.data = data;
                        $scope.isLogged = true;
                        $scope.logByApp = false;
                        $scope.registerByApp = false;
                        $scope.showAlert('Success', 'User Logged');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        //deferred.reject();
                        $scope.showAlert('Error', 'User Logged');
                        console.log('error');
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.refreshComplete');
                        $scope.Name.data = '';
                        $scope.password.data = '';

                    });
        
    };
    $scope.logout = function () {
        $timeout(function () {
            var db = null;
            // for opening a background db:
            if (window.cordova) {
                db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
                //alert("Android");
            } else {
                db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
                //alert("browser");

            }
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS UserData');
                $scope.isLogged = false;
                $scope.showAlert('Success', 'User Logout');
                //alert('Drop Done');
            });
        },100);
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

});
