﻿app.controller('NewsCtrl', function ($scope, $stateParams, ionicMaterialInk, $http, $q, $ionicLoading, $cordovaSQLite, $ionicPopup) {
    //ionic.material.ink.displayEffect();
    //ionicMaterialInk.displayEffect();
    $scope.data = [];
    $scope.counter = 0;
    $scope.targetData = [];
    $scope.isAr = false;
    $scope.Title = '';
    //$scope.$on('$ionicView.enter', function () {
    //    // code to run each time view is entered
    //    $scope.getData();
    //});
    
    
    $scope.getData = function () {
        
        
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.counter = 0;
        $scope.targetData = [];
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var deferred = $q.defer();
        
        //db.transaction(function (tx) {
        //    tx.executeSql('SELECT * FROM sqlite_master', [], function (tx, rs) {
        //        alert('');
        //    })
        //});
        db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS Events (ID, Title,Description,TitleAr,DescriptionAr,Details,DetailsAr,StartDate,EndDate,Map,MainImage,EventPlace,CreatedAt,ModifiedAt)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS EventNews (ID,EventId,Title,TitleAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CreatedAt,ModifiedAt,CurrentDate)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS EventNewsImage (ID,EventId,EventNewsId, ImagePath,CreatedAt,ModifiedAt)');

            tx.executeSql('SELECT MAX(CurrentDate) as MAXDATE FROM EventNews', [], function (tx, rs) {
                var parameter = '';
                    if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                        parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                    
                    }
                    else {
                        var parameter = '';
                    }
                $http.get('http://ksazoo.com/breeze/mobile/getEventNews' + parameter)
                    .success(function (data) {
                        //$scope.data = data;
                        //alert(data.length)
                        $ionicLoading.hide();
                        $scope.populateDate(data);
                        

                        //deferred.resolve(data);
                        // $scope.data = data;

                        //$scope.$broadcast('scroll.refreshComplete');
                        // sqlite



                        //end sqlite
                    })
                    .error(function (e) {
                        $scope.populateDate(null);
                        if ($scope.isAr) {
                            $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                        } else {
                            $scope.showAlert('Internet Connection', 'No Internet Connection');
                        }
                        //deferred.reject();
                        console.log('error');
                        $ionicLoading.hide();
                        //$scope.$broadcast('scroll.refreshComplete');

                    });
                
            }, function (tx, error) {

                db.transaction(function (tx) {
                    tx.executeSql('DROP TABLE IF EXISTS Events');
                    tx.executeSql('DROP TABLE IF EXISTS EventNews');
                    tx.executeSql('DROP TABLE IF EXISTS EventNewsImage');
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
        
       // $scope.data = deferred.promise;
    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.getData();
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'News';
        } else {
            $scope.isAr = true;
            $scope.Title = 'الاخبار';
        }
    });

    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length > 20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Title: item.Title,
                        TitleAr: item.TitleAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        Details: item.Details,
                        DetailsAr: item.DetailsAr,
                        MainImage: item.MainImage,
                        CreatedAt: item.CreatedAt,
                        ModifiedAt: item.ModifiedAt,
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.populateDate = function (data) {
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'News';
        } else {
            $scope.isAr = true;
            $scope.Title = 'الاخبار';
        }
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO EventNews VALUES (?,?,?,?,?,?,?,?,?,?,?,?)'
                            , [item.ID,
                                item.EventId,
                                item.Title,
                                item.TitleAr,
                                item.Description,
                                item.DescriptionAr,
                                item.Details,
                                item.DetailsAr,
                                item.MainImage,
                                item.CreatedAt,
                                item.ModifiedAt,
                                item.CurrentDate
                            ]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE EventNews SET Title=?,TitleAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CreatedAt=?,ModifiedAt=?,CurrentDate=? WHERE ID=?'
                            , [item.Title,
                                item.TitleAr,
                                item.Description,
                                item.DescriptionAr,
                                item.Details,
                                item.DetailsAr,
                                item.MainImage,
                                item.CreatedAt,
                                item.ModifiedAt,
                                item.CurrentDate,
                                item.ID
                            ]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  EventNews where ID=?', [item.ID]);
                    }
                    item.EventImages.forEach(function (img) {
                        if (img.Status == 1) {
                            tx.executeSql('INSERT INTO EventNewsImage VALUES (?,?,?,?,?,?)'
                             , [img.ID,
                                img.EventId,
                                img.EventNewsId,
                                img.ImagePath,
                                img.CreatedAt,
                                img.ModifiedAt,
                             ]);
                        } else if (img.Status == 2) {
                            tx.executeSql('UPDATE EventNewsImage SET ImagePath=?,CreatedAt=?,ModifiedAt=? where ID=? '
                             , [
                                img.ImagePath,
                                img.CreatedAt,
                                img.ModifiedAt,
                                img.ID
                             ]);
                        } else if (img.Status == 3) {
                            tx.executeSql('DELETE FROM  EventNewsImage where ID=?', [img.ID]);
                        }

                    });
                });
            }
            tx.executeSql('SELECT * FROM EventNews order by ID DESC', [], function (tx, rs) {
                for (var i = 0; i < rs.rows.length; i++) {
                    //for (var i = 0; i < rs.rows.length; i++) {
                    $scope.data.push({
                        RowId: i + 1,
                        ID: rs.rows.item(i).ID,
                        Title: rs.rows.item(i).Title,
                        TitleAr: rs.rows.item(i).TitleAr,
                        Description: rs.rows.item(i).Description,
                        DescriptionAr: rs.rows.item(i).DescriptionAr,
                        Details: rs.rows.item(i).Details,
                        DetailsAr: rs.rows.item(i).DetailsAr,
                        MainImage: rs.rows.item(i).MainImage,
                        CreatedAt: rs.rows.item(i).CreatedAt,
                        ModifiedAt: rs.rows.item(i).ModifiedAt,
                    });
                    //}

                }
                $scope.data.forEach(function (item) {
                    if (item.RowId <= 20) {
                        $scope.targetData.push({
                            RowId: item.RowId,
                            ID: item.ID,
                            Title: item.Title,
                            TitleAr: item.TitleAr,
                            Description: item.Description,
                            DescriptionAr: item.DescriptionAr,
                            Details: item.Details,
                            DetailsAr: item.DetailsAr,
                            MainImage: item.MainImage,
                            CreatedAt: item.CreatedAt,
                            ModifiedAt: item.ModifiedAt,
                        });
                    }
                });
                $scope.counter += 20;
            });



        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS Events');
                tx.executeSql('DROP TABLE IF EXISTS EventNews');
                tx.executeSql('DROP TABLE IF EXISTS EventNewsImage');
                alert('Transaction ERROR: ' + error.message);
            });
        }, function () {
            //alert('Populated database OK');

        });
    };
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };

});