﻿app.controller('NewsDetailsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();

    $scope, data = null;
    $scope.dataImages = null;
    $scope.isAr = false;
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
        } else {
            $scope.isAr = true;
        }
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        } else {
        }
    });
    $scope.getData = function (Id) {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        var deferred = $q.defer()

        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM EventNews where ID = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    $scope.data = {
                        ID: rs.rows.item(0).ID,
                        Title: rs.rows.item(0).Title,
                        TitleAr: rs.rows.item(0).TitleAr,
                        Description: rs.rows.item(0).Description,
                        DescriptionAr: rs.rows.item(0).DescriptionAr,
                        Details: rs.rows.item(0).Details,
                        DetailsAr: rs.rows.item(0).DetailsAr,
                        MainImage: rs.rows.item(0).MainImage,
                    };
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
            tx.executeSql('SELECT * FROM EventNewsImage where EventNewsId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.dataImages.push({ID: rs.rows.item(i).ID, ImagePath: rs.rows.item(i).ImagePath});
                    }
                    $ionicLoading.hide();
                }
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });
        //$http.get('http://ksazoo.com/breeze/mobile/getEventDetails?Id=' + Id)
        //.success(function (data) {
        //    deferred.resolve(data);
        //    $scope.data = data;
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //})
        //.error(function (e) {
        //    deferred.reject();
        //    console.log('error');
        //    $ionicLoading.hide();
        //    $scope.$broadcast('scroll.refreshComplete');
        //});
        //$scope.data = deferred.promise;
    };
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };
});