﻿app.controller('QuestionnaireCtrl', function ($scope, $stateParams, $ionicActionSheet, $timeout, $ionicLoading, $ionicModal, $ionicPopup, ionicMaterialInk, ionicMaterialMotion, $http, $q, $cordovaSQLite) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.counter = 0;
    $scope.targetData = [];
    $scope.title = 'الاستبيانات';
    $scope.isAr = false;


    //login info
    $scope.isLogged = false;
    $scope.userName = null;
    $scope.userId = null;
    $scope.UserType = null;


    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        //$scope.getUser();
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Questionnaire';
        } else {
            $scope.isAr = true;
            $scope.title = 'الاستبيانات';
        }
    });
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };
    $scope.getData = function () {
        //$scope.getUser();
        $scope.counter = 0;
        $scope.targetData = [];
        $scope.data = [];
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var deferred = $q.defer();
        db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS Questionnaires (ID, Name,NameAr,Description,DescriptionAr,Details,DetailsAr,MainImage,CurrentDate)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS Questions (ID,QuestionnaireId, QuestionText,QuestionTextAr,IsChoosed)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS QuestionOptions (ID,QuestionId,questionnaireId, Name,NameAr,IsChoosed)');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    //$ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        //$ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        //$ionicLoading.hide();
                    }
                    tx.executeSql('SELECT MAX(CurrentDate) as MAXDATE FROM Questionnaires', [], function (tx, rs) {
                        var parameter = '';
                        if (rs.rows.length > 0 && rs.rows.item(0).MAXDATE) {
                            parameter += '?dateStr=' + rs.rows.item(0).MAXDATE;
                            if ($scope.userId) {
                                parameter += '&userId=' + $scope.userId;
                            }
                        }
                        else {
                            var parameter = '';
                            if ($scope.userId) {
                                parameter += '?userId=' + $scope.userId;
                            }
                        }

                        $http.get('http://ksazoo.com/breeze/mobile/GetUserQuestionnaire' + parameter)
                            .success(function (data) {
                                //$scope.data = data;
                                
                                $scope.populateData(data)
                                //deferred.resolve(data);
                                // $scope.data = data;
                                //$ionicLoading.hide();
                                $scope.$broadcast('scroll.refreshComplete');
                                // sqlite



                                //end sqlite
                            })
                            .error(function (e) {
                                $scope.populateData(null)
                                if ($scope.isAr) {
                                    $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                                } else {
                                    $scope.showAlert('Internet Connection', 'No Internet Connection');
                                }
                                //deferred.reject();
                                console.log('error');
                                $ionicLoading.hide();
                                $scope.$broadcast('scroll.refreshComplete');

                            });

                    }, function (tx, error) {
                        tx.executeSql('DROP TABLE IF EXISTS Questionnaires');
                        tx.executeSql('DROP TABLE IF EXISTS Questions');
                        tx.executeSql('DROP TABLE IF EXISTS QuestionOptions');
                        alert('SELECT error: ' + error.message);
                        $ionicLoading.hide();
                    });
                }, function (tx, error) {
                    tx.executeSql('DROP TABLE IF EXISTS Questionnaires');
                    tx.executeSql('DROP TABLE IF EXISTS Questions');
                    tx.executeSql('DROP TABLE IF EXISTS QuestionOptions');
                    tx.executeSql('DROP TABLE IF EXISTS UserData');
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
            
        });

    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.getUser = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            //tx.executeSql('DROP TABLE IF EXISTS UserData');
            tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS UserData');
                tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
                tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
                    $ionicLoading.hide();
                    if (rs.rows.length > 0) {
                        //alert('there is data');
                        $scope.isLogged = true;
                        $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
                        $scope.userId = rs.rows.item(0).UserID;
                        $scope.UserType = rs.rows.item(0).UserType;

                        $ionicLoading.hide();
                    } else {
                        $scope.isLogged = false;
                        $ionicLoading.hide();
                    }
                }, function (tx, error) {
                    alert('SELECT error: ' + error.message);
                    $ionicLoading.hide();
                });
            });
        });
    };
    $scope.getData();
    $scope.urlForImage = function (i) {
        if (i) {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png'
        }
    };

    $scope.loadMore = function () {
        if ($scope.counter > 0 && $scope.data.length > 20) {
            $scope.data.forEach(function (item) {
                if (item.RowId > $scope.counter && item.RowId <= $scope.counter + 20) {
                    $scope.targetData.push({
                        RowId: item.RowId,
                        ID: item.ID,
                        Name: item.Name,
                        NameAr: item.NameAr,
                        Description: item.Description,
                        DescriptionAr: item.DescriptionAr,
                        Details: item.Details,
                        DetailsAr: item.DetailsAr,
                        MainImage: item.MainImage
                    });
                }
            });
            $scope.counter += 20;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    $scope.populateData = function (data) {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            if (data) {
                data.forEach(function (item) {
                    if (item.Status == 1 || item.Status == 0) {
                        tx.executeSql('INSERT INTO Questionnaires VALUES (?,?,?,?,?,?,?,?,?)',
                         [item.ID, item.Name, item.NameAr,
                             item.Description, item.DescriptionAr,
                             item.Details, item.DetailsAr, item.Image, item.CurrentDate]);
                    } else if (item.Status == 2) {
                        tx.executeSql('UPDATE Questionnaires SET Name=?,NameAr=?,Description=?,DescriptionAr=?,Details=?,DetailsAr=?,MainImage=?,CurrentDate=? where ID=?',
                         [item.Name, item.NameAr,
                             item.Description, item.DescriptionAr,
                             item.Details, item.DetailsAr, item.Image, item.CurrentDate, item.ID]);
                    } else if (item.Status == 3) {
                        tx.executeSql('DELETE FROM  Questionnaires where ID=?', [item.ID]);
                    }
                    item.Questions.forEach(function (q) {
                        if (q.Status == 1 || q.Status == 0) {
                            tx.executeSql('INSERT INTO Questions  VALUES (?,?,?,?,?)',
                        [q.ID, item.ID, q.QuestionText, q.QuestionTextAr, 0]);
                        } else if (q.Status == 2) {
                            tx.executeSql('UPDATE Questions  SET QuestionText=?,QuestionTextAr=? WHERE ID=?',
                        [q.QuestionText, q.QuestionTextAr, q.ID]);
                        } else if (q.Status == 3) {
                            tx.executeSql('DELETE FROM  Questions where ID=?', [q.ID]);
                        }

                        q.Options.forEach(function (option) {
                            if (option.Status == 1 || q.Status == 0) {
                                tx.executeSql('INSERT INTO QuestionOptions  VALUES (?,?,?,?,?,?)',
                                [option.ID, q.ID, item.ID, option.Name, option.NameAr, option.IsChoosed == true ? 1 : 0]);
                            } else if (option.Status == 2) {
                                tx.executeSql('UPDATE QuestionOptions SET Name=?,NameAr=? where ID=? ',
                                [option.Name, option.NameAr, option.ID]);

                            } else if (option.Status == 3) {
                                tx.executeSql('DELETE FROM  QuestionOptions where ID=?', [option.ID]);
                            }

                        });
                    });
                });
            }
            tx.executeSql('SELECT * FROM Questionnaires order by ID DESC', [], function (tx, rs) {
                //for (var i = 0; i < rs.rows.length; i++) {
                for (var i = 0; i < rs.rows.length; i++) {
                    $scope.data.push({
                        RowId: i + 1,
                        ID: rs.rows.item(i).ID,
                        Name: rs.rows.item(i).Name,
                        NameAr: rs.rows.item(i).NameAr,
                        Description: rs.rows.item(i).Description,
                        DescriptionAr: rs.rows.item(i).DescriptionAr,
                        Details: rs.rows.item(i).Details,
                        DetailsAr: rs.rows.item(i).DetailsAr,
                        MainImage: rs.rows.item(i).MainImage
                    });
                }
                $scope.data.forEach(function (item) {
                    if (item.RowId <= 20) {
                        $scope.targetData.push({
                            RowId: item.RowId,
                            ID: item.ID,
                            Name: item.Name,
                            NameAr: item.NameAr,
                            Description: item.Description,
                            DescriptionAr: item.DescriptionAr,
                            Details: item.Details,
                            DetailsAr: item.DetailsAr,
                            MainImage: item.MainImage
                        });
                    }
                });
                $scope.counter += 20;


            });
            $ionicLoading.hide();


        }, function (error) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS Questionnaires');
                tx.executeSql('DROP TABLE IF EXISTS Questions');
                tx.executeSql('DROP TABLE IF EXISTS QuestionOptions');
                alert('Transaction ERROR: ' + error.message);
                $ionicLoading.hide();
            });
        }, function () {
            //alert('Populated database OK');
            $ionicLoading.hide();
        });
    };
    
    $scope.showAlert = function (title, msg) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            template: msg
        });
    };
    


});