app.controller('RequestsCtrl', function ($scope, $stateParams, ionicMaterialInk, $http, $q, $ionicLoading, $cordovaSQLite, ionicMaterialMotion) {
  //ionic.material.ink.displayEffect();
  $scope.data = [];
  $scope.isAr = false;
  $scope.Title = '';

  //login info
  $scope.isLogged = false;
  $scope.userName = null;
  $scope.userId = null;
  $scope.UserType = null;
  //data
  $scope.requestData = []
  $scope.loading = function () {
    $ionicLoading.show({
      template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
    });

    // For example's sake, hide the sheet after two seconds
    $timeout(function () {
      $ionicLoading.hide();
    }, 1000);
  };



  $scope.$on('$ionicView.enter', function () {
    // code to run each time view is entered
    if (document.cookie == "zooWeb=en") {
      $scope.isAr = false;
      $scope.Title = 'Vistors Requests';
    } else {
      $scope.isAr = true;
      $scope.Title = 'طلبات الزيارة';
    }
    $scope.getData()
  });
  $scope.getData = function () {
    $ionicLoading.show({
      template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
    });
    var db = null;
    // for opening a background db:
    if (window.cordova) {
      db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
      //alert("Android");
    } else {
      db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
      //alert("browser");

    }
    $scope.data = [];
    db.transaction(function (tx) {
      //tx.executeSql('DROP TABLE IF EXISTS UserData');
      tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID, Name,Password,UserType)');
      db.transaction(function (tx) {
        //tx.executeSql('DROP TABLE IF EXISTS UserData');
        tx.executeSql('CREATE TABLE IF NOT EXISTS UserData (UserID,SocialId, Name,Password,UserType)');
        tx.executeSql('SELECT * FROM UserData', [], function (tx, rs) {
          //$ionicLoading.hide();
          if (rs.rows.length > 0) {
            //alert('there is data');
            $scope.isLogged = true;
            $scope.userName = rs.rows.item(0).Name + ' From ' + rs.rows.item(0).UserType;
            $scope.userId = rs.rows.item(0).UserID;
            $scope.UserType = rs.rows.item(0).UserType;

            
            $http.get('http://ksazoo.com/breeze/mobile/GetUserVisitRequests?userId=' + $scope.userId)
              .success(function (data) {
                $ionicLoading.hide();
                $scope.requestData = data;

              })
              .error(function (e) {
                deferred.reject();
                console.log('error');
                $ionicLoading.hide();
                $scope.populateData(null);
                if ($scope.isAr) {
                  $scope.showAlert('الاتصال بالانترنت', 'لا يوجد اتصال انترنت');
                } else {
                  $scope.showAlert('Internet Connection', 'No Internet Connection');
                }

                //$scope.$broadcast('scroll.refreshComplete');


              });
          } else {
            $scope.isLogged = false;
            $ionicLoading.hide();
          }
        }, function (tx, error) {
          alert('SELECT error: ' + error.message);
          $ionicLoading.hide();
        });
      });
    });
    

  };
  $scope.scrollSmallToTop = function () {
    $scope.getData();
  };
  $scope.urlForImage = function (i) {
    if (i && i != "undefined") {
      return 'http://ksazoo.com/Uploads/thumbs1/' + i;
    } else {
      return 'img/no_image.png';
    }
  };
  $scope.$on('$ionicView.enter', function () {
    // code to run each time view is entered
    if (document.cookie == "zooWeb=en") {
      $scope.isAr = false;
    } else {
      $scope.isAr = true;
    }
  });

});
