app.controller('SettingsCtrl', function ($scope, $stateParams, ionicMaterialInk, $ionicLoading, $http, $q, $cordovaSQLite, $cordovaEmailComposer, $ionicPopup, $timeout, $ionicPlatform, $cordovaPushV5) {
    //ionic.material.ink.displayEffect();
    $scope.title = 'الاعدادات';
    $scope.isAr = false;
    $scope.deleteCookies = function () {
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        db.transaction(function (tx) {
            tx.executeSql('DROP TABLE IF EXISTS Animals');
            tx.executeSql('DROP TABLE IF EXISTS Animal');
            tx.executeSql('DROP TABLE IF EXISTS Events');
            tx.executeSql('DROP TABLE IF EXISTS EventNews');
            tx.executeSql('DROP TABLE IF EXISTS EventNewsImage');
            tx.executeSql('DROP TABLE IF EXISTS Ticket');
            tx.executeSql('DROP TABLE IF EXISTS ServicesCategory');
            tx.executeSql('DROP TABLE IF EXISTS Services');
            tx.executeSql('DROP TABLE IF EXISTS Menus');
            tx.executeSql('DROP TABLE IF EXISTS MenuItems');
            tx.executeSql('DROP TABLE IF EXISTS TicketType');
            tx.executeSql('DROP TABLE IF EXISTS Ticket');
            tx.executeSql('DROP TABLE IF EXISTS Vistor');
            tx.executeSql('DROP TABLE IF EXISTS VistorType');
            tx.executeSql('DROP TABLE IF EXISTS VistorDay');
            tx.executeSql('DROP TABLE IF EXISTS Questionnaires');
            tx.executeSql('DROP TABLE IF EXISTS Questions');
            tx.executeSql('DROP TABLE IF EXISTS QuestionOptions'); 
            tx.executeSql('DROP TABLE IF EXISTS Competation');
            tx.executeSql('DROP TABLE IF EXISTS AnimalImages');
            tx.executeSql('DROP TABLE IF EXISTS AnimalVideos'); 
            tx.executeSql('DROP TABLE IF EXISTS CompanyProfile');
            tx.executeSql('DROP TABLE IF EXISTS Gallery');
            tx.executeSql('DROP TABLE IF EXISTS GalleryDetails'); 
            tx.executeSql('DROP TABLE IF EXISTS UserData'); 
            var alertPopup = $ionicPopup.alert({
                title: 'Delete All Cookies',
                template: 'Data Deleted'
            });
            //alert('Drop Done');
        });
    };
    $scope.getToken = function () {
      window.FirebasePlugin.getToken(function (token) {
        // save this server-side and use it to push notifications to this device
        alert(token);
        alert(window.navigator.platform);
        if ($ionicPlatform.is('android')) {
          alert("Android device");
        }

        if ($ionicPlatform.is('ios')) {
          alert("iOS device");
        }
      }, function (error) {
        alert(error);
        });

      //var app = {
      //  initialize: function () {
      //    this.bindEvents();
      //  },
      //  bindEvents: function () {
      //    document.addEventListener('deviceready', this.onDeviceReady, false);
      //  },
      //  onDeviceReady: function () {
      //    app.receivedEvent('deviceready');
      //    devicePush.register({
      //      idUser: 'USER_ID', // Your User ID in Device Push 
      //      idApplication: 'APPLICATION_ID', // Aplication ID in Device Push 
      //      position: true ,// Activate or deactivate gps position record. Default value is false 
      //          additionalData: {} // Include additional data of the current user for targeting 
      //    });
      //  },
      //  receivedEvent: function (id) { }
      //};

      //document.addEventListener("deviceRegistered", successDeviceRegistered, false);
      //function successDeviceRegistered(evt) {
      //  alert("Device Id" + evt.devicePushId);
      //  var id = evt.devicePushId;
      //  alert("Device Token" + evt.devicePushToken);
      //  var tokenDevice = evt.devicePushToken;
      //}
      //$ionicPlatform.ready(function () {
      //  var push = new Ionic.Push({
      //    "debug": true
      //  });

      //  push.register(function (token) {
      //    alert("Device token:", token.token);
      //  });
      //});
      //$ionicPlatform.ready(function () {
      //  var options = {
      //    android: {
      //      senderID: "145257823222"
      //    },
      //    ios: {
      //      alert: "true",
      //      badge: "true",
      //      sound: "true"
      //    },
      //    windows: {}
      //  };
      //  $cordovaPushV5.register(options).then(function (registrationId) {
      //    // save `registrationId` somewhere;
      //    alert(registrationId)
      //  })
      //});
        //var push = new Ionic.Push({
        //  "onNotification": function (notification) {
        //    var payload = notification.payload;
        //    console.log(payload);
        //    console.log(notification);
        //    console.log("notification received");
        //  },
        //  "onRegister": function (data) {
        //    console.log(data.token);
        //    alert(data.token);
        //    var reg = {
        //      regId: data.token
        //    };
        //  }
        //});
      
    };

    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        //$scope.getUser();
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.title = 'Settings';
        } else {
            $scope.isAr = true;
            $scope.title = 'الاعدادات';
        }
    });

});
