﻿app.controller('VistorCtrl', function ($scope, $stateParams, ionicMaterialInk, $http, $q, $ionicLoading, $cordovaSQLite, ionicMaterialMotion) {
    //ionic.material.ink.displayEffect();
    $scope.data = [];
    $scope.isAr = false;
    $scope.Title = '';
    $scope.loading = function () {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });

        // For example's sake, hide the sheet after two seconds
        $timeout(function () {
            $ionicLoading.hide();
        }, 1000);
    };



    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
            $scope.Title = 'Vistors';
        } else {
            $scope.isAr = true;
            $scope.Title = 'الزوار';
        }
        if ($stateParams.ID) {
            $scope.getData($stateParams.ID)
        }
    });
    $scope.getData = function (Id) {
        $ionicLoading.show({
            template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
        });
        var db = null;
        // for opening a background db:
        if (window.cordova) {
            db = $cordovaSQLite.openDB({ name: "rdyzoo.db", location: 2, createFromLocation: 1 }); //device
            //alert("Android");
        } else {
            db = window.openDatabase("rdyzoo.db", '1', 'rdyzoo', 1024 * 1024 * 100); // browser
            //alert("browser");

        }
        $scope.data = [];
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM VistorDay where VistorTypeId = ' + Id, [], function (tx, rs) {
                if (rs.rows.length > 0) {
                    for (var i = 0; i < rs.rows.length; i++) {
                        $scope.data.push({
                            ID: rs.rows.item(i).ID,
                            Name: rs.rows.item(i).Name,
                            NameAr: rs.rows.item(i).NameAr,
                            Title: rs.rows.item(i).Title,
                            TitleAr: rs.rows.item(i).TitleAr,
                            Description: rs.rows.item(i).Description,
                            DescriptionAr: rs.rows.item(i).DescriptionAr,
                            TimeFrom: rs.rows.item(i).TimeFrom,
                            TimeTo: rs.rows.item(i).TimeTo,
                        });
                    }
                    $ionicLoading.hide();
                }
                $ionicLoading.hide();
            }, function (tx, error) {
                alert('SELECT error: ' + error.message);
                $ionicLoading.hide();
            });
        });

    };
    $scope.scrollSmallToTop = function () {
        $scope.getData();
    };
    $scope.urlForImage = function (i) {
        if (i && i != "undefined") {
            return 'http://ksazoo.com/Uploads/thumbs1/' + i;
        } else {
            return 'img/no_image.png';
        }
    };
    $scope.$on('$ionicView.enter', function () {
        // code to run each time view is entered
        if (document.cookie == "zooWeb=en") {
            $scope.isAr = false;
        } else {
            $scope.isAr = true;
        }
    });

});